snake = {
		x = 0,
		y = 0,
		timer = {tick = 0, interval = 12},
		direction = "right", --right left up down
		has_moved = false,
		length = 24,
		tail = {},
		lost = false
	}
	
tail_minAlpha = 30
tail_maxAlpha = 255
tail_fade = 40

function snake:reset()
	self.x = math.floor((screen.w / 2) / game_scale)
	self.y = math.floor((screen.h / 2) / game_scale)
	self.direction = "right"
	self.tail = {}
	
	self.lost = false
	
end

function snake:update(dt)
	self.timer.tick = self.timer.tick + dt
	if self.timer.tick > 1 / self.timer.interval then
		if not self.lost then
			snake:move()
		end
		self.timer.tick = 0
	end
end

function snake:move()
	local next_position = {x = self.x, y = self.y}
	
	if self.direction == "right" then
		next_position.x = next_position.x + 1
	elseif self.direction == "left" then
		next_position.x = next_position.x - 1
	elseif self.direction == "down" then
		next_position.y = next_position.y + 1
	elseif self.direction == "up" then
		next_position.y = next_position.y - 1
	end
	
	--Tail update
	self.tail[#self.tail + 1] = {--Add Tail segment
			x = self.x,
			y = self.y
		}
	if #self.tail > self.length then
		table.remove(self.tail, 1)
	end
	
	--Tail collision check
	local col = false
	for i,v in ipairs(self.tail) do
		if v.x == next_position.x and v.y == next_position.y then
			self.lost = true
			break
		end
	end
	
	if self.lost then
		self:reset()
	else
	
		--Actual position update
		self.x = next_position.x
		self.y = next_position.y
		
		self.has_moved = false
	end
end

function snake:draw()
	--Head
	love.graphics.setColor(color.snake)
	love.graphics.rectangle("fill", self.x * game_scale, self.y * game_scale, game_scale, game_scale)
	
	--Tail
	local r, g, b = love.graphics.getColor()
	for i,v in ipairs(self.tail) do
	
		local a = -255 / i
		
		if a < tail_minAlpha then
			--a = tail_minAlpha
		elseif a > tail_maxAlpha then
			a = tail_maxAlpha
		end
		
		love.graphics.setColor(r, g, b, a)
		love.graphics.rectangle("fill", v.x * game_scale, v.y * game_scale, game_scale, game_scale)
	end
end 
